local nahjSize = 1; --change this to scale the frame
queueTimeFrame = CreateFrame("Frame","QueueTimeFrame",self, BackdropTemplateMixin and "BackdropTemplate")

function queueTimeFrame_OnUpdate(self, elapsed)
if not SDB.A_TIMEINQUEUE == true then return end
  if not self.TimeSinceLastUpdate then self.TimeSinceLastUpdate = 0 end
  self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	
  local ui = 1
  local inQueue = false;
	for i=1, GetMaxBattlefieldID() do
			local status, mapName, teamSize, registeredMatch, suspend = GetBattlefieldStatus(i);
			if ( status and status ~= "none" ) then
				if ( status == "queued" and not suspend) then
					inQueue = true;
				elseif ( status == "active" ) then
					inQueue = false;
				end
			end
	end

  while (self.TimeSinceLastUpdate > ui) do
	if QueueStatusFrame.statusEntriesPool.activeObjects and inQueue then
		local counter = 0;
		for i, _ in pairs(QueueStatusFrame.statusEntriesPool.activeObjects) do
			if (queueTimeFrame:GetAlpha() == 0) then
				queueTimeFrame:SetAlpha(1);
			end
			if ( i.queuedTime ) then
				counter = counter + 1;
				local elapsed = GetTime() - i.queuedTime ;
				if (counter > 1) then
					queueTimeFrame.fs:SetFormattedText(queueTimeFrame.fs:GetText().."\n\n"..TIME_IN_QUEUE, (elapsed >= 60) and SecondsToTime(elapsed) or LESS_THAN_ONE_MINUTE);
				else
					queueTimeFrame.fs:SetFormattedText(TIME_IN_QUEUE, (elapsed >= 60) and SecondsToTime(elapsed) or LESS_THAN_ONE_MINUTE);
				end
			else
				queueTimeFrame.fs:SetFormattedText(TIME_IN_QUEUE, LESS_THAN_ONE_MINUTE);
			end
		end
		if QueueStatusFrame.statusEntriesPool.numActiveObjects == 0 then
			if (queueTimeFrame:GetAlpha() == 1) and (queueTimeFrame.locked) then
				queueTimeFrame:SetAlpha(0);
			end
		else
			queueTimeFrame:SetHeight(20 * QueueStatusFrame.statusEntriesPool.numActiveObjects);
		end
	else
		if (queueTimeFrame:GetAlpha() == 1) and (queueTimeFrame.locked) then
			queueTimeFrame:SetAlpha(0);
		end
	end

    self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - ui;
  end
end
queueTimeFrame:SetScript("OnUpdate", queueTimeFrame_OnUpdate)

queueTimeFrame:Show()
queueTimeFrame.locked = true;
queueTimeFrame:SetBackdrop({bgFile = [[Interface\Buttons\WHITE8X8]]})
queueTimeFrame:SetBackdropColor(0,0,0,0.5);
queueTimeFrame:SetFrameStrata("BACKGROUND");
queueTimeFrame:SetAlpha(0);
queueTimeFrame:ClearAllPoints();
queueTimeFrame:SetWidth(150)
queueTimeFrame:SetHeight(20)
queueTimeFrame:SetPoint("CENTER", UIParent, "CENTER",0, 0)
queueTimeFrame.fs = queueTimeFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
queueTimeFrame.fs:SetText("Time In Queue: ");
queueTimeFrame.fs:SetPoint("CENTER",queueTimeFrame)
queueTimeFrame:SetScale(nahjSize);

--apply drag functionality to any frame
  local applyDragFunctionality = function(self)
    --save the default position
    local getPoint = function(self)
      local pos = {}
      pos.a1, pos.af, pos.a2, pos.x, pos.y = self:GetPoint()
      if pos.af and pos.af:GetName() then pos.af = pos.af:GetName() end
      return pos
    end
    self.defaultPosition = getPoint(self)
    --the drag frame
    local df = CreateFrame("Frame",nil,self)
    df:SetAllPoints(self)
    df:SetFrameStrata("HIGH")
    df:SetHitRectInsets(0,0,0,0)
    df:SetScript("OnDragStart", function(self) self:GetParent():StartMoving() end)
    df:SetScript("OnDragStop", function(self) self:GetParent():StopMovingOrSizing() end)
    --dragframe texture
    local t = df:CreateTexture(nil,"OVERLAY",nil,6)
    t:SetAllPoints(df)
    t:SetTexture(0,1,0)
    t:SetAlpha(0.2)
    --stuff
    df.texture = t
    df:Hide()
    self.dragframe = df
    self:SetClampedToScreen(true)
    self:SetMovable(true)
    self:SetUserPlaced(true)
    --helper functions
    --unlock
    local unlock = function(self)
      if not self:IsUserPlaced() then return end
      self.dragframe:Show()
      self.dragframe:EnableMouse(true)
      self.dragframe:RegisterForDrag("LeftButton")
      self.dragframe:SetScript("OnEnter", function(self)
        GameTooltip:SetOwner(self, "ANCHOR_TOP")
        GameTooltip:AddLine(self:GetParent():GetName(), 0, 1, 0.5, 1, 1, 1)
        GameTooltip:AddLine("Click to drag", 1, 1, 1, 1, 1, 1)
        GameTooltip:Show()
      end)
      self.dragframe:SetScript("OnLeave", function() GameTooltip:Hide() end)
    end
    --lock
    local lock = function(self)
      if not self:IsUserPlaced() then return end
      self.dragframe:Hide()
      self.dragframe:EnableMouse(false)
      self.dragframe:RegisterForDrag(nil)
      self.dragframe:SetScript("OnEnter", nil)
      self.dragframe:SetScript("OnLeave", nil)
    end
    --reset position
    local reset = function(self)
      if self.defaultPosition then
        self:ClearAllPoints()
        local pos = self.defaultPosition
        if pos.af and pos.a2 then
          self:SetPoint(pos.a1 or "CENTER", pos.af, pos.a2, pos.x or 0, pos.y or 0)
        elseif pos.af then
          self:SetPoint(pos.a1 or "CENTER", pos.af, pos.x or 0, pos.y or 0)
        else
          self:SetPoint(pos.a1 or "CENTER", pos.x or 0, pos.y or 0)
        end
      else
        self:SetPoint("CENTER",0,0)
      end
    end
    self.unlock = unlock
    self.lock = lock
    self.reset = reset
  end
queueTimeFrame.dragMe = applyDragFunctionality;
queueTimeFrame.dragMe(queueTimeFrame)

SLASH_TIMEINQ1 = '/tiq'; -- 3.
function SlashCmdList.TIMEINQ(msg, editbox) -- 4.
	if msg == "unlock" then
		queueTimeFrame:SetAlpha(1);
		queueTimeFrame.unlock(queueTimeFrame)
		queueTimeFrame.locked = false;
	elseif msg == "lock" then
		queueTimeFrame:SetAlpha(0);
		queueTimeFrame.lock(queueTimeFrame)
		queueTimeFrame.locked = true;
	end
end

print("|cffffd700Jax TimeInQueue:|r Loaded.\nCommands:\n/tiq unlock \n/tiq lock");
