SDB = {}

local STRONGUI=CreateFrame("Frame")
STRONGUI:RegisterEvent("PLAYER_LOGIN")
STRONGUI:SetScript("OnEvent", function(self, event)

print("Welcome to |cFFFFFFFFStrongstyle|r|cFFFF0000UI|r use |CFFFE8A0E/STRONGUI|r for Options.")

--SavedVariables Defaults
local defaults = {
	A_UNITFRAMES = true,
	A_CUSTOMBARS = true,
	A_STATS = true,
    A_EASYDELETE = true,
	A_TOOLTIP = true,
	A_SHOWRAID = false,
	A_ITEMLEVEL = true,
	A_FRIENDLIST = true,
	A_CHARLINKS = true,
	A_AUTOREP = true,
	A_DAMPENING = true,
	A_TIMEINQUEUE =true,

	TOOLTIP = {
		X = -10,
		Y = 180,
		MOUSE = false,
	},

	STATS = {
		ACTIV = true,
		POINT = "BOTTOMRIGHT",
		PARENT = "UIParent",
		RELPOINT = "BOTTOMRIGHT",
		X = -315,
		Y = 5,
		SIZE = 13,
		COLOR = true,
		CLOCK = false,
	},
	background = {
		showbg = true,
		showshadow = true,
		useflatbackground = false,
		backgroundcolor = {r = 0.2, g = 0.2, b = 0.2, a = 0.3},
		shadowcolor = {r = 0, g = 0, b = 0, a = 0.9},
		classcolored = false,
		inset = 5
	},
	color = {
		maincolor = {r = 0.37, g = 0.3, b = 0.3},
		normal = {r = 0.37, g = 0.3, b = 0.3},
		equipped = {r = 0.1, g = 0.5, b = 0.1},
		classcolored = false
	},
	hotkeys = {
		show = false,
		fontsize = 12,
		pos1 = {a1 = "TOPRIGHT", x = 0, y = 0},
		pos2 = {a1 = "TOPLEFT", x = 0, y = 0}
	},
	macroname = {
		show = false,
		fontsize = 12,
		pos1 = {a1 = "BOTTOMLEFT", x = 0, y = 0},
		pos2 = {a1 = "BOTTOMRIGHT", x = 0, y = 0}
	},
	itemcount = {
		show = true,
		fontsize = 12,
		pos1 = {a1 = "BOTTOMRIGHT", x = 0, y = 0}
	},
	cooldown = {
		spacing = 0
	},
	adjustOneletterAbbrev = true,
	consolidatedTooltipScale = 1.2,
	combineBuffsAndDebuffs = false
}

--CopyDefaults
local function STRONGUICopyDefaults(src, dst)
	if type(src) ~= "table" then return {} end
	if type(dst) ~= "table" then dst = { } end
	for k, v in pairs(src) do
	if type(v) == "table" then
		dst[k] = STRONGUICopyDefaults(v, dst[k])
		elseif type(v) ~= type(dst[k]) then
		dst[k] = v
		end
	end
		return dst
end

SDB = STRONGUICopyDefaults(defaults, SDB)

if SDB.A_DEFAULTS == nil then
	StaticPopupDialogs["INSTALL"] = {
		text = "Welcome to Strongstyle UI, Please Support me on Twitch.tv/StrongstyleGG",
		button1 = "Install",
		OnAccept = function()
			SDB.A_DEFAULTS = true
			ReloadUI()
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
		preferredIndex = 3
	}
	StaticPopup_Show("INSTALL")
end

end)

--STRONGUIConfigFrame
local function STRONGUICreateConfig()
	--FRAME
	local STRONGUIConfig = CreateFrame("Frame", "STRONGUIConfig", UIParent, "ButtonFrameTemplate")
	--change to logo
	SetPortraitToTexture(STRONGUIConfig.portrait, "Interface\\Icons\\spell_nature_bloodlust")
	STRONGUIConfig:SetSize(450, 525)
	STRONGUIConfig:SetPoint("CENTER")
	STRONGUIConfig:SetClampedToScreen(true)
	STRONGUIConfig:EnableMouse(true)
	STRONGUIConfig:SetMovable(true)
	STRONGUIConfig:RegisterForDrag("LeftButton")
	STRONGUIConfig:SetScript("OnDragStart",function(self)self:StartMoving()end)
	STRONGUIConfig:SetScript("OnDragStop",function(self)self:StopMovingOrSizing()end)
	STRONGUIConfig:Hide()

	local STRONGUIConfigTitle = STRONGUIConfig:CreateFontString(nil, STRONGUIConfig, "GameFontNormalLarge")
	STRONGUIConfigTitle:SetPoint("TOP", 0, -32)
	STRONGUIConfigTitle:SetText("Strongstyle UI Config v0.1")

	local STRONGUIConfigTwitch = STRONGUIConfig:CreateFontString(nil, STRONGUIConfig, "GameFontNormalLarge")
	STRONGUIConfigTwitch:SetPoint("BOTTOMRIGHT", STRONGUIConfig, "BOTTOMRIGHT", -10, 5)
	STRONGUIConfigTwitch:SetText("Twitch.tv/StrongstyleGG")
	STRONGUIConfigTwitch:SetTextColor(248, 248, 255)

	--COLOR
	for i, v in pairs(
		{
		STRONGUIConfigBg,
		STRONGUIConfigTitleBg
		}
		) do
		v:SetVertexColor(.40, .40, .40)
	end

	for i, v in pairs(
		{
		STRONGUIConfigPortraitFrame,
		STRONGUIConfig.NineSlice.TopEdge,
		STRONGUIConfig.NineSlice.BottomEdge,
		STRONGUIConfig.NineSlice.RightEdge,
		STRONGUIConfig.NineSlice.LeftEdge,
		STRONGUIConfig.NineSlice.TopLeftCorner,
		STRONGUIConfig.NineSlice.BottomLeftCorner,
		STRONGUIConfig.NineSlice.TopRightCorner,
		STRONGUIConfig.NineSlice.BottomRightCorner,
		}
		) do
		v:SetVertexColor(.30, .30, .30)
	end
end
STRONGUICreateConfig()

--STRONGUI SHOW
local function STRONGUICONFIGSHOW()
	--Backdrop
	local backdrop = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile = true,
		tileSize = 32,
		edgeSize = 32,
	}

	--POPUPS
	local function HELP()
		StaticPopupDialogs["HELP"] = {
		--TODO: update links
			text = "Pls report Errors/Bugs/Issues on Curseforge.com/wow/addons/STRONGUI",
			button1 = "Close",
			button2 = "Reset UI",
			OnAccept = function()
				STRONGUICONFIGSHOW()
			end,
			OnCancel = function()
				SDB = nil
				ReloadUI()
			end,
			timeout = 0,
			whileDead = true,
			hideOnEscape = true,
			preferredIndex = 3
		}
		StaticPopup_Show("HELP")
	end

	--STRONGUI BUTTONS
	local function STRONGUICreateBTN(text,point1,anchor,point2,pos1,pos2,width,height)
		STRONGUIBTN = CreateFrame("Button", nil, STRONGUIConfig, "UIPanelButtonTemplate")
		STRONGUIBTN:SetPoint(point1, anchor, point2, pos1, pos2)
		STRONGUIBTN:SetWidth(width)
		STRONGUIBTN:SetHeight(height)
		STRONGUIBTN:SetText(text)
	end

	--STRONGUI TEXT
	local function STRONGUICreateTXT(text,anchor,point,pos1,pos2, ...)
		STRONGUITXT = STRONGUIConfig:CreateFontString(nil, STRONGUIConfig, "GameFontNormalLarge")
		STRONGUITXT:SetPoint(point, anchor, pos1, pos2)
		STRONGUITXT:SetText(text)
	end

	--STRONGUI CHECKBOX
	local function STRONGUICreateCB(name,anchor,tooltip,db, ...)
		STRONGUICheckbox = CreateFrame("CheckButton", nil , STRONGUIConfig, "OptionsBaseCheckButtonTemplate")
		STRONGUICheckbox:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", 0, -5)

		STRONGUICheckbox:SetScript(
			"OnClick",
			function(frame)
				local tick = frame:GetChecked()
				SDB[db] = tick
				if tick then
					DEFAULT_CHAT_FRAME:AddMessage(name .. " Enabled", 0, 1, 0)
					SDB[db] = true
				else
					DEFAULT_CHAT_FRAME:AddMessage(name .. " Disabled", 1, 0, 0)
					SDB[db] = false
				end
			end
		)
		STRONGUICheckbox:SetScript(
			"OnShow",
			function(frame)
				frame:SetChecked(SDB[db])
			end
		)

		STRONGUICheckbox:SetScript(
			"OnEnter",
			function(self)
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOM")
				GameTooltip:AddLine(tooltip, 248, 248, 255)
				GameTooltip:Show()
			end
		)
		STRONGUICheckbox:SetScript("OnLeave", GameTooltip_Hide)

		text = STRONGUIConfig:CreateFontString(nil, STRONGUIConfig, "GameFontHighlight")
		text:SetPoint("LEFT", STRONGUICheckbox, "RIGHT", 0, 1)
		text:SetText(name)

	end

	--BUTTONS
	STRONGUICreateBTN("Save & Reload","BOTTOMLEFT",STRONGUIConfig,"BOTTOMLEFT",16,35,100,25)
	STRONGUIBTN:SetScript(
		"OnClick",
		function(self, button, down)
			ReloadUI()
		end
	)

	STRONGUICreateBTN("Help & Reset","BOTTOMLEFT",STRONGUIConfig,"BOTTOMLEFT",120,35,100,25)
	STRONGUIBTN:SetScript(
		"OnClick",
		function(self, button, down)
			STRONGUIConfig:Hide()
			HELP()
		end
	)
	--UI
	STRONGUICreateTXT("Display Options",STRONGUIConfig,"TOPLEFT",20,-75)

	--SPACE
	STRONGUICreateTXT("",STRONGUIConfig,"TOPLEFT",20,-100)

	STRONGUICreateCB("Unitframes",STRONGUITXT,"Custom UnitFrames","A_UNITFRAMES")
	STRONGUICreateCB("Custom Bars",STRONGUICheckbox,"Custom Bar Layout","A_CUSTOMBARS")
	STRONGUICreateCB("Tooltip",STRONGUICheckbox,"Custom Tooltips","A_TOOLTIP")
	STRONGUICreateCB("Friendlist",STRONGUICheckbox,"Friendlist Class Colors","A_FRIENDLIST")
	STRONGUICreateCB("Dampening",STRONGUICheckbox,"Show Dampening in Arena","A_DAMPENING")


	--SPACE
	STRONGUICreateTXT("",STRONGUIConfig,"TOPLEFT",180,-100)
	
	STRONGUICreateCB("Keys",STRONGUITXT,"Hide Keys on Actionbar","A_HOTKEYS")
	STRONGUICreateCB("Macros",STRONGUICheckbox,"Hide Macros Names on Actionbar","A_MACROS")
	STRONGUICreateCB("System Stats",STRONGUICheckbox,"System Stats Frame","A_STATS")
	STRONGUICreateCB("Time in Queue",STRONGUICheckbox,"Shows time in Queue","A_TIMEINQUEUE")

	--SPACE
	STRONGUICreateTXT("",STRONGUITXT,"CENTER",150,0)
	

--[[
	NextBlock
  ]]--
	--MISC
	STRONGUICreateTXT("Core Options",STRONGUIConfig,"TOPLEFT",20,-270)

	--SPACE
	STRONGUICreateTXT("",STRONGUIConfig,"TOPLEFT",20,-295)

	STRONGUICreateCB("ShowRaid",STRONGUITXT,"Show RaidFrame without group","A_SHOWRAID")
	STRONGUICreateCB("Charlinks",STRONGUICheckbox,"Charlinks on UnitFrame Menu","A_CHARLINKS")
    STRONGUICreateCB("AutoRep",STRONGUICheckbox,"Auto Repair","A_AUTOREP")
	STRONGUICreateCB("Itemlevel",STRONGUICheckbox,"Item Level","A_ITEMLEVEL")
    STRONGUICreateCB("EasyDelete",STRONGUICheckbox,"Easy delete Items","A_EASYDELETE")
	--END
	
	--SPACE
	STRONGUICreateTXT("",STRONGUIConfig,"TOPLEFT",180,-295)
   --[[
       NextBlock
     ]]--
	--END

	--SPACE
	STRONGUICreateTXT("",STRONGUITXT,"CENTER",150,0)
   --[[
       NextBlock
     ]]--
	--END

	STRONGUIConfig:Show()
end

local activ = false
function openSTRONGUI()
	if activ == false then
		STRONGUICONFIGSHOW()
		activ = true
	else
		STRONGUIConfig:Show()
	end
end

GameMenuFrame.Header:Hide()
local frame = CreateFrame("Button","UIPanelButtonTemplateTest",
GameMenuFrame, "UIPanelButtonTemplate")
frame:SetHeight(20)
frame:SetWidth(145)
frame:SetText("|cFFFFFFFFStrongstyle|r|cFFFF0000UI|r")
frame:ClearAllPoints()
frame:SetPoint("TOP", 0, -11)
frame:RegisterForClicks("AnyUp")
frame:SetScript("OnClick", function()
	openSTRONGUI()
	ToggleGameMenu();
end)
SlashCmdList["STRONGUI"] = function() openSTRONGUI() end
SLASH_STRONGUI1 = "/STRONGUI"