local STRONGUI=CreateFrame("Frame")
STRONGUI:RegisterEvent("PLAYER_LOGIN")
STRONGUI:SetScript("OnEvent", function(self, event)

if not SDB.A_SHOWRAID == true then return end

local t = {
	Blizzard_CompactRaidFrames = true,
	Blizzard_CUFProfiles = true
}

-- Can't hard disable if this is on.
hooksecurefunc("DisableAddOn",function(addon)
	if t[addon] then
		EnableAddOn(addon)
	end
end)

if not IsAddOnLoaded("Blizzard_CompactRaidFrames") then
	for k in pairs(t) do
		EnableAddOn(k)
	end

	local old = SetItemRef

	function SetItemRef(...)
		local link = ...
		if link == "reload" then
			ReloadUI()
		else
			old(...)
		end
	end

	print("|cff33FF99ShowRaidFrame:|r Requires |cffFF8040|Hreload|h[Reload]|h|r")
	return
end

local nah = function()
end

-- Thou shalt not hide the Raid Frames
for _, v in ipairs({CompactRaidFrameManager, CompactRaidFrameContainer}) do
	v.UnregisterAllEvents = nah
	v.UnregisterEvent = nah

	v.Hide = nah -- Prevents other addon interference
	v:Show() -- Gives Priority to UI before other addons to Show
end

if not FixRaidTaint then
	local container = CompactRaidFrameContainer

	local t = {
		discrete = "flush",
		flush = "discrete"
	}

	-- refresh the raid frames after combat
	local function OnEvent(self)
		-- secure (prob not) or still in combat?
		if issecurevariable("CompactRaidFrame1") or InCombatLockdown() or not container:IsShown() then
			return
		end

		-- change back and forth from flush <-> discrete
		local mode = container.groupMode -- groupMode changes after _SetGroupMode calls
		CompactRaidFrameContainer_SetGroupMode(container, t[mode]) -- forth
		CompactRaidFrameContainer_SetGroupMode(container, mode) -- back
	end

	local f = CreateFrame("Frame", "FixRaidTaint")
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:SetScript("OnEvent", OnEvent)

	f.version = 0.2
end

-- sets the USE_RAID_STYLE_PARTY_FRAMES CVar
SetCVar("useCompactPartyFrames", 1)

-- maybe disable the option for showing party frames since we're not allowed to hide raid frames now TBD
--CompactUnitFrameProfilesRaidStylePartyFrames:Disable()
end)